/******************************************************************/
/*                                                                */
/*                      TurboCAD for Windows                      */
/*                   Copyright (c) 1993 - 2001                    */
/*             International Microcomputer Software, Inc.         */
/*                            (IMSI)                              */
/*                      All rights reserved.                      */
/*                                                                */
/******************************************************************/

// stdafx.h : include file for standard system include files,
//      or project specific include files that are used frequently,
//      but are changed infrequently

#if !defined(AFX_STDAFX_H__9690A7B2_9D66_493A_A4B3_A122ACB7A17A__INCLUDED_)
#define AFX_STDAFX_H__9690A7B2_9D66_493A_A4B3_A122ACB7A17A__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#define STRICT
#ifndef _WIN32_WINNT
#define _WIN32_WINNT 0x0400
#endif
#define _ATL_APARTMENT_THREADED

#include <afxwin.h>
#include <afxdisp.h>
#include <afxtempl.h>


#include <atlbase.h>
//You may derive a class from CComModule and use it if you want to override
//something, but do not change the name of _Module
extern CComModule _Module;
#include <atlcom.h>

#include <atlcom.h>
extern COleVariant varMissing;
extern COleVariant varTrue;
extern COleVariant varFalse;

// TurboCAD SDK: Interfaces for Imsigx objects
#include "imsigx.h"

#include "xdbtool.h"

#include <comdef.h>

#define TYPELIB_MAJOR	1
#define TYPELIB_MINOR	0
#define NUM_TOOLS		1


#define CHECK_HRESULT(hr) if (FAILED(hr)) throw hr;
#define CHECK_POINTER(p) if (p == NULL) throw E_OUTOFMEMORY;
#define TRACE_EXCEPTION(f) TRACE1("Exception in %s\n", ##f);

#define RELEASE(pI) if (pI != NULL) {pI->Release(); pI = NULL;}
#define ADDREF(pI) pI != NULL ? pI->AddRef() : 0;

#define FOR_EACH(INTERFACE, pObj, pObjs)					\
	{														\
		HRESULT hr = S_OK;									\
		ULONG celt = 1;										\
		ULONG fetched = 0;									\
		VARIANT varObj;										\
		::VariantInit(&varObj);								\
		IEnumVARIANT* pEnum = NULL;							\
		try													\
		{													\
			hr = pObjs->get__NewEnum((IUnknown**)&pEnum);	\
			if (FAILED(hr)) throw hr;						\
			hr = pEnum->Reset();							\
			if (FAILED(hr)) throw hr;						\
			while (TRUE)									\
			{												\
				::VariantClear(&varObj);					\
				pObj = NULL;								\
				hr = pEnum->Next(celt, &varObj, &fetched);	\
				if (fetched == 0)							\
					break;									\
				pObj = (##INTERFACE *)varObj.pdispVal;		 


#define NEXT(pObj)				\
			}						\
		}							\
		catch (...)					\
		{							\
		}							\
		::VariantClear(&varObj);	\
		if (pEnum != NULL)			\
			pEnum->Release();		\
		pObj = NULL;				\
	}

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_STDAFX_H__9690A7B2_9D66_493A_A4B3_A122ACB7A17A__INCLUDED)
